From 38def709355504953940d11a6045bec68c9b450b Mon Sep 17 00:00:00 2001
From: wk3368 <wk3368@163.com>
Date: Fri, 18 Nov 2022 22:09:44 +0800
Subject: [PATCH] Add entryFunctionPayload in txParams for Dapps to
 sendUncheckedTransaction in Aptos networks

---
 src/providers/jsonrpc-provider.ts | 14 +++++++++++++-
 src/types/index.ts                |  7 +++++++
 2 files changed, 20 insertions(+), 1 deletion(-)

diff --git a/src/providers/jsonrpc-provider.ts b/src/providers/jsonrpc-provider.ts
index 32c583e..0978154 100644
--- a/src/providers/jsonrpc-provider.ts
+++ b/src/providers/jsonrpc-provider.ts
@@ -366,7 +366,14 @@ export class JsonRpcSigner extends Signer {
 // }
 
 const allowedTransactionKeys: { [key: string]: boolean } = {
-  chainId: true, data: true, gasLimit: true, gasPrice: true, nonce: true, to: true, value: true
+  chainId: true,
+  data: true,
+  entryFunctionPayload: true,
+  gasLimit: true,
+  gasPrice: true,
+  nonce: true,
+  to: true,
+  value: true,
 }
 export class JsonRpcProvider extends BaseProvider {
   readonly connection: ConnectionInfo;
@@ -794,6 +801,11 @@ export class JsonRpcProvider extends BaseProvider {
       result[key] = hexlify((<any>transaction)[key]);
     });
 
+    ["entryFunctionPayload"].forEach(function (key) {
+      if ((<any>transaction)[key] == null) { return; }
+      result[key] = (<any>transaction)[key];
+    });
+
     return result;
   }
 }
diff --git a/src/types/index.ts b/src/types/index.ts
index 5b51f59..16a537c 100644
--- a/src/types/index.ts
+++ b/src/types/index.ts
@@ -327,6 +327,13 @@ export interface TransactionRequest {
   expiredSecs?: U64;
   addGasBufferMultiplier?: U8;
 
+  entryFunctionPayload?: {
+    type?: string,
+    function: string,
+    type_arguments: Array<string>,
+    arguments: Array<any>,
+  };
+
   sender?: AccountAddress;
   sender_public_key?: HexString;
   sequence_number?: U64;
